<script lang="ts" setup>
import { computed, ref } from 'vue'
import GitlabHelperApi from '@/api/gitlabHelperApi'

const props = defineProps<{
  user: {
    id: number
    username: string
    email: string
    surname_1: string
    surname_2: string
    role: string
  }
}>()
const password = ref(window.GITLAB_DEFAULT_PASSWORD)
const username_prefix = ref(window.GITLAB_USERNAME_PREFIX)

const saving = ref(false)
const isError = ref(false)
const isRequest = ref(false)
const requestMessage = ref('')
const passwordFieldType = ref('password')
const isAdmin = ref(false)

const alertToggleVariant = computed(() => isError.value ? 'error' : 'success')
const alertToggleText = computed(() => isError.value ? 'Error!' : 'Success!')
const passwordToggleIcon = computed(() => passwordFieldType.value === 'password' ? 'mdi-eye' : 'mdi-eye-off')

const addGitLabUser = async () => {
  saving.value = true
  const gitlabHelper = new GitlabHelperApi()
  try {
    // TODO: Need to be extenalize
    let { username, email, id } = props.user
    if (username_prefix.value !== null && username_prefix.value !== undefined)
      username = `${username_prefix.value}_${props.userData.username}`
    const fullName = `${props.user.surname_1} ${props.user.surname_2}, ${props.user.name}`
    const response = await gitlabHelper.createGitLabToken(
      email, fullName, username, id, password.value, isAdmin.value,
    )
    
    console.log('::AddGitlabUser.vue:: createGitLabToken response.data: ', response.data)
    
    requestMessage.value = response.data.message
    isError.value = false
    emit('finished')
  }
  catch (error) {
    console.log('************* Alex ERROR')
    console.error('error addGitLabUser', error.response.data)
    requestMessage.value = error.response.data.message
    isError.value = true
  }
  saving.value = false
  isRequest.value = true
}

const togglePassword = () => {
  passwordFieldType.value = passwordFieldType.value === 'password' ? 'text' : 'password'
}
</script>

<template>
  <VContainer
    ref="addGitlabUserForm"
    class="mt-2"
  >
    <VRow>
      <VCol cols="12">
        <VAlert
          v-if="isRequest"
          :color="alertToggleVariant"
          :type="alertToggleVariant"
          dense
          border="start"
        >
          <VIcon
            left
            size="22"
          >
            mdi-information
          </VIcon>
          <strong>{{ alertToggleText }}</strong> {{ requestMessage }}.
        </VAlert>
      </VCol>
    </VRow>
    <VRow>
      <VCol
        cols="12"
        sm="6"
      >
        <VTextField
          v-model="password"
          label="Temporal password"
          :type="passwordFieldType"
          append-icon="passwordToggleIcon"
          class="mt-4"
          @click:append="togglePassword"
        />
      </VCol>
      <VCol
        v-if="['admin', 'root'].includes(user.role.toLowerCase())"
        cols="12"
        sm="6"
      >
        <VSwitch
          v-model="isAdmin"
          label="Admin capabilities"
          class="mt-4"
          color="primary"
        >
          GitLab administrator
        </VSwitch>
      </VCol>
    </VRow>
    <VRow>
      <VCol cols="12">
        <VBtn
          color="primary"
          class="mt-2"
          :disabled="saving"
          @click="addGitLabUser"
        >
          <VProgressCircular
            v-if="saving"
            indeterminate
            size="20"
          />
          <span v-if="saving">Creating user and token...</span>
          <span v-else>Create user and token</span>
        </VBtn>
      </VCol>
    </VRow>
  </VContainer>
</template>

<style scoped>
</style>
